//+------------------------------------------------------------------+
//|                                                 LC Histogram.mq4 |
//|                                    Franco Mocke & Dwight Futrell |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Franco Mocke"
#property link      ""

#define LONG 0
#define SHORT 1
#define SIDEWAYS 2

extern int SlowMAPeriod = 50;
extern int FastMAperiod = 15;
extern int PriceMaxDistancePipsFromFastMA = 50;

#property indicator_chart_window

#property indicator_buffers 5
#property indicator_color1 Purple
#property indicator_color2 Purple
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Yellow


//---- indicator buffers
double SlowMAHigh[];
double SlowMALow[];
double FastMALong[];
double FastMAShort[];
double FastMANoTrade[];


int z = 1;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

if (Digits == 5 || Digits == 3) {z = 10;}

SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,2);
SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,2);

SetIndexBuffer(0, SlowMAHigh);
SetIndexBuffer(1, SlowMALow);
SetIndexBuffer(2, FastMALong);
SetIndexBuffer(3, FastMAShort);
SetIndexBuffer(4, FastMANoTrade);


   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
//----

   double dist = 0;
   
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   int bars = Bars - counted_bars;


   for (int i = 0; i < bars; i++)
   {
      double SlowMAH =iMA(Symbol(),Period(),SlowMAPeriod,0,MODE_EMA,PRICE_HIGH,i);
      double SlowMAL =iMA(Symbol(),Period(),SlowMAPeriod,0,MODE_EMA,PRICE_LOW,i);
           
      double FastMA = iMA(Symbol(),Period(),FastMAperiod,0,MODE_EMA,PRICE_CLOSE,i);
      
      double low = iLow(Symbol(),Period(),i);
      double high = iHigh(Symbol(),Period(),i);
      
      
      SlowMAHigh[i] = SlowMAH;
      SlowMALow[i] = SlowMAL;
      

      
      if (FastMA > SlowMAH && FastMA > SlowMAL)
      {
         dist = (low - FastMA)/Point/z;
         
         if (dist <=PriceMaxDistancePipsFromFastMA )
         {
            FastMALong[i] = FastMA;
         }
      }
      
      
      
     
      if (FastMA < SlowMAH && FastMA < SlowMAL)
      {
         dist = (FastMA - high)/Point/z;
         
         if (dist <=PriceMaxDistancePipsFromFastMA )
         {
            FastMAShort[i] = FastMA;
         }
         
      }
      
      
      
      if (FastMAShort[i] == 2147483647 && FastMALong[i] == 2147483647)
      {
         FastMANoTrade[i] = FastMA;
      }
      

      
      }



//----
   return(0);
  }
//+------------------------------------------------------------------+