//+------------------------------------------------------------------+
//|                                                  eFibo_CT_EA.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern int grid=50;                 //Number of Pips Up or Down
extern int stop_loss=250;           //Fixed stoploss in pips (0=no stoploss)
extern int take_profit=250;         //Fixed takeprofit in pips (0=no takeprofit)
extern int slippage=3;              //Allowed slippage of open order
extern int trailing_stop=50;        //Trailing stop distance in pips

extern bool use_random=false;       //Random function toggle, if true then variable grid,stop_loss,take_profit,trailing stop will be reandomize
extern double random_percent=10;    //percent of randomize, variable that is randomized will be between up and below of the percentage of the defined variable
extern double lots_start=0.01;      //Start Lot size if no open trade available 
extern double multiplier=2;         //Multiplier of lot size every level
extern double max_lots=50;          //Maximum lots that can be traded in a single trade

extern bool close_all_positive_positions=true;  //if true and all sum of current open trades is positive, , it will close all open trades at the time below. 
extern bool close_at_5pm=true;                  //if true and close_all_positive_positions=true,  it will close all open trades at 5 pm.
extern bool close_at_11pm=true;                 //if true and close_all_positive_positions=true,  it will close all open trades at 11 pm.
extern bool close_at_2am=true;                  //if true and close_all_positive_positions=true,  it will close all open trades at 2 am.
extern bool close_at_5am=true;                  //if true and close_all_positive_positions=true,  it will close all open trades at 5 am.
extern bool close_at_7am=true;                  //if true and close_all_positive_positions=true,  it will close all open trades at 7 am.

extern double account_protection_percent=2;     //Close all positions when percentage of Account Profit is negative and below this level.
extern double symbol_protection_percent=1;      //Close all positions when percentage of all current profit of the Symbol() is negative and below this level.
extern int max_trades=5;                        //Maximum open trades that can be opened

extern bool order_protection=true;                 //Order protection toggle
extern int order_protection_number_trades=3;       //Number of trades to activate order protection
extern bool order_protection_close_if_flat=true;   //Close all current symbol() open position if current profit == 0
extern int order_protection_pips_profit=10;        //Close all current symbol() open position if current profit pips reach this number

extern bool trade_certain_times=true;              //Time toggle to trade on different session
extern bool trade_on_london=true;                  //Time toggle to trade on london session
extern bool trade_on_newyork=true;                 //Time toggle to trade on new york session
extern bool trade_on_tokyo=true;                   //Time toggle to trade on tokyo session


extern int  london_open_hour=9;                    //London open hour time
extern int  london_open_minute=0;                  //London open minute time
extern int  london_close_hour=17;                  //London close hour Time
extern int  london_close_minute=0;                 //London close minute time

extern int  newyork_open_hour=9;                   //New york open hour time  
extern int  newyork_open_minute=0;                 //New york open minute time
extern int  newyork_close_hour=17;                 //New york close hour time
extern int  newyork_close_minute=0;                //New York close minute time

extern int  tokyo_open_hour=9;                     //Tokyo open hour time
extern int  tokyo_open_minute=0;                   //Tokyo open minute time
extern int  tokyo_close_hour=17;                   //Tokyo close hour time
extern int  tokyo_close_minute=0;                  //Tokyo close minute time

extern bool close_on_weekend=true;                 //Toggle to close all position of the symbol on the end of weekend

extern int weekly_open_hour=19;                    //Weekly open hour time
extern int weekly_open_minute=0;                   //Weekly open minute time
extern int weekly_close_hour=16;                   //Weekly close hour time
extern int weekly_close_minute=0;                  //Weekly close minute time

extern int magic_number=382618;                    //Magic Number

double     myPoint, mySpread, myStopLevel,myTickValue,myTickSize,myLotValue;
int        myDigits;
double     last_price;
double     last_ask;
double     last_bid;
bool       enableopen;
bool       enable_ea;
double     my_lots;
int        digit_lot;
int        count_order;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

SetPoint();
/*
if (use_random)
   {
      grid=MathRandRange(random_percent,grid);
      stop_loss=MathRandRange(random_percent,stop_loss);
      take_profit=MathRandRange(random_percent,take_profit);
      trailing_stop=MathRandRange(random_percent,trailing_stop);
   }*/
if(MarketInfo(Symbol(),MODE_MINLOT)==0.01)
   {
      digit_lot=2;   
   }
if(MarketInfo(Symbol(),MODE_MINLOT)==0.1)
   {
      digit_lot=1;   
   }
if(MarketInfo(Symbol(),MODE_MINLOT)==1)
   {
      digit_lot=0;   
   }
      
last_bid=Bid;
last_ask=Ask;
last_price=0;
my_lots=lots_start;
enable_ea=true;
count_order=0;
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
   
   enableopen=true;
   bool enable_london=true;
   bool enable_newyork=true;
   bool enable_tokyo=true;
   
   
   


   
   if (trade_certain_times)
      {
         if(trade_on_london)
            {
               if(!istradinghours(london_open_hour,london_close_hour,london_open_minute,london_close_minute))
                  {      
                     enable_london = false;
                  }
            }
         else enable_london=false; 
          
         if(trade_on_newyork)
            {
               if(!istradinghours(newyork_open_hour,newyork_close_hour,newyork_open_minute,newyork_close_minute))
                  {      
                     enable_newyork = false;
                  }
            }
          else enable_newyork=false;  
            
         if(trade_on_tokyo)
            {
               if(!istradinghours(tokyo_open_hour,tokyo_close_hour,tokyo_open_minute,tokyo_close_minute))
                  {      
                     enable_tokyo = false;
                  }
            }
          else enable_tokyo=false;              
         
         if(!enable_london && !enable_newyork && !enable_tokyo)
         {
            enableopen=false;
            Comment("out of trading hours\n");
         }
      }
   
   if (close_on_weekend)
      {
         if (TimeDayOfWeek(TimeCurrent())==5 && !istradinghours(0,weekly_close_hour,0,weekly_close_minute))
            {
               enableopen=false;
               Comment("out of trading hours\n");
            }
      }

   if (close_on_weekend)
      {
         if (TimeDayOfWeek(TimeCurrent())==0 && !istradinghours(weekly_open_hour,24,weekly_open_minute,0))
            {
               enableopen=false;
               Comment("out of trading hours\n");
            }
      }
      
   
   //---------------------------------Close on weekend--------------------------------
   if(close_on_weekend && istradinghours(weekly_close_hour,weekly_close_hour,weekly_close_minute,weekly_close_minute+2))
      {
         if (CountOpenOrders(OP_BUY)+CountOpenOrders(OP_SELL)>0)
         { 
            CloseTrades(OP_BUY);
            CloseTrades(OP_SELL);   
         }
      }



   //--------------------------Account and Symbol Protection--------------------------------

   if (CountOpenOrders(OP_BUY)+CountOpenOrders(OP_SELL)>0)
      {   
         if(AccountProfit()*100 / AccountBalance()<=-1*account_protection_percent) 
            {
               //Close all position when account protection percent reach and stop EA trading
               CloseAll(OP_BUY);
               CloseAll(OP_SELL);
               enable_ea=false;               
            }
            
         if(current_symbol_profit()*100 / AccountBalance()<=-1*symbol_protection_percent) 
            {
               //Close all position when symbol protection percent reach
               CloseTrades(OP_BUY);
               CloseTrades(OP_SELL);               
            }

         
         
    //---------------------------------Order Protection--------------------------------
         
         if(order_protection && CountOpenOrders(OP_BUY)+CountOpenOrders(OP_SELL)>=order_protection_number_trades)
            {
               if(order_protection_close_if_flat && current_symbol_profit_pips()==0)
                  {
                     //Close all postition if flat (orderprofit ==0)
                     CloseTrades(OP_BUY);
                     CloseTrades(OP_SELL);  
                  }
               if(current_symbol_profit_pips()>=order_protection_pips_profit)
                  {
                     //Close all position when pips_profit reach
                     CloseTrades(OP_BUY);
                     CloseTrades(OP_SELL); 
                  }       
            }  
         
         
    //-------------Close all positive position at certain times------------------------
         
         if (close_all_positive_positions && current_symbol_profit()>0)
            {
               if(close_at_5pm && istradinghours(17,17,0,2))
                  {
                     CloseTrades(OP_BUY);
                     CloseTrades(OP_SELL); 
                  }                                  
               if(close_at_11pm && istradinghours(23,23,0,2))
                  {
                     CloseTrades(OP_BUY);
                     CloseTrades(OP_SELL); 
                  }    
               if(close_at_2am && istradinghours(2,2,0,2))
                  {
                     CloseTrades(OP_BUY);
                     CloseTrades(OP_SELL); 
                  } 
               if(close_at_5am && istradinghours(5,5,0,2))
                  {
                     CloseTrades(OP_BUY);
                     CloseTrades(OP_SELL); 
                  } 
               if(close_at_7am && istradinghours(7,7,0,2))
                  {
                     CloseTrades(OP_BUY);
                     CloseTrades(OP_SELL); 
                  } 
            }                             
      }

    //---------------------------------OPEN ORDERS--------------------------------

      if (enableopen && enable_ea && my_lots<=max_lots)
         {
            //Random function to activate
            int mygrid=grid;
            int mysl=stop_loss;
            int mytp=take_profit;
            
            
            if (use_random)
               {
                  mygrid=MathRandRange(random_percent,grid);
                  mysl=MathRandRange(random_percent,stop_loss);
                  mytp=MathRandRange(random_percent,take_profit); 
               }
            
            
            double sl;
            double tp;
             
            if(CountOpenOrders(OP_BUY)+CountOpenOrders(OP_SELL)==0)
               { 
                  if(Bid>=last_bid+(mygrid*myPoint))
                     {
                        my_lots=lots_start;
                        if(mysl==0) sl=0;
                        if(mysl>0) sl=Bid+(mysl*myPoint);
                        if(mytp==0) tp=0;
                        if(mytp>0) tp=Bid-(mytp*myPoint);
                        //OrderSend(Symbol(),OP_SELL,my_lots,Bid,slippage,Bid+(stop_loss*myPoint),Bid-(take_profit*myPoint),"[Sell eFibo_CT]",magic_number,0,CLR_NONE);
                        OrderSend(Symbol(),OP_SELL,my_lots,Bid,slippage,sl,tp,"[Sell eFibo_CT]",magic_number,0,CLR_NONE);
                        my_lots=NormalizeDouble(my_lots*multiplier,digit_lot);
                        //count_order++;
                        //if(count_order==max_trades) count_order=0;
                        
                        last_ask=Ask;
                        last_bid=Bid;
                     }
                  if(Ask<=last_ask-(mygrid*myPoint))
                     {
                        my_lots=lots_start;
                        if(mysl==0) sl=0;
                        if(mysl>0) sl=Ask-(mysl*myPoint);
                        if(mytp==0) tp=0;
                        if(mytp>0) tp=Ask+(mytp*myPoint);
                        //OrderSend(Symbol(),OP_BUY,my_lots,Ask,slippage,Ask-(stop_loss*myPoint),Ask+(take_profit*myPoint),"[Buy eFibo_CT]",magic_number,0,CLR_NONE);                        
                        OrderSend(Symbol(),OP_BUY,my_lots,Ask,slippage,sl,tp,"[Buy eFibo_CT]",magic_number,0,CLR_NONE);                        
                        my_lots=NormalizeDouble(my_lots*multiplier,digit_lot);
                        //count_order++;
                        //if(count_order==max_trades) count_order=0;
                        last_ask=Ask;
                        last_bid=Bid;
                     }   
               }
               
            if(CountOpenOrders(OP_SELL)>0 && CountOpenOrders(OP_SELL)<max_trades)
               { 
                  if(Bid>=last_bid+(mygrid*myPoint))
                     {
                        if(mysl==0) sl=0;
                        if(mysl>0) sl=Bid+(mysl*myPoint);
                        if(mytp==0) tp=0;
                        if(mytp>0) tp=Bid-(mytp*myPoint);
                        //OrderSend(Symbol(),OP_SELL,my_lots,Bid,slippage,Bid+(stop_loss*myPoint),Bid-(take_profit*myPoint),"[Sell eFibo_CT]",magic_number,0,CLR_NONE);
                        OrderSend(Symbol(),OP_SELL,my_lots,Bid,slippage,sl,tp,"[Sell eFibo_CT]",magic_number,0,CLR_NONE);
                        my_lots=NormalizeDouble(my_lots*multiplier,digit_lot);
                        //count_order++;
                        //if(count_order==max_trades) count_order=0;
                        last_ask=Ask;
                        last_bid=Bid;
                     }
               }        
            if(CountOpenOrders(OP_BUY)>0 && CountOpenOrders(OP_BUY)<max_trades)
               { 
                  if(Ask<=last_ask-(mygrid*myPoint))
                     {
                        if(mysl==0) sl=0;
                        if(mysl>0) sl=Ask-(mysl*myPoint);
                        if(mytp==0) tp=0;
                        if(mytp>0) tp=Ask+(mytp*myPoint);
                        //OrderSend(Symbol(),OP_BUY,my_lots,Ask,slippage,Ask-(stop_loss*myPoint),Ask+(take_profit*myPoint),"[Buy eFibo_CT]",magic_number,0,CLR_NONE);                        
                        OrderSend(Symbol(),OP_BUY,my_lots,Ask,slippage,sl,tp,"[Buy eFibo_CT]",magic_number,0,CLR_NONE);                        
                        my_lots=NormalizeDouble(my_lots*multiplier,digit_lot);
                        //count_order++;
                        //if(count_order==max_trades) count_order=0;
                        last_ask=Ask;
                        last_bid=Bid;
                     }   
               }    
                                 
         }

    //---------------------------------Trailing Stop--------------------------------

      int mytrail=trailing_stop;
      if(trailing_stop>0)
         {
            if(use_random)
            {
               mytrail=MathRandRange(random_percent,trailing_stop);
            }
            TrailingPositionsBuy(mytrail);
            TrailingPositionsSell(mytrail);         
         }
   
   

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+-------------------------General Functions------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+-------------------------General Variable-------------------------+

void SetPoint()
{

   myPoint     =  MarketInfo(Symbol(),MODE_POINT);
   mySpread    =  MarketInfo(Symbol(),MODE_SPREAD);
   myDigits    =  MarketInfo(Symbol(),MODE_DIGITS);
   myStopLevel =  MarketInfo(Symbol(),MODE_STOPLEVEL);
   myTickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
   myTickSize = MarketInfo(Symbol(),MODE_TICKSIZE);
   myLotValue = myTickValue/myTickSize;

   if(
         myDigits==3    ||  
         myDigits==5
     )
      {
         myPoint     =  myPoint  *  10;
         mySpread    =  mySpread /  10;
         myStopLevel =  myStopLevel / 10;
         myDigits    =  myDigits -1;
      }    

}

//+------------------------------------------------------------------+
//+----------------------Trading Hours-------------------------------+

bool istradinghours(int starthour, int endhour, int startminute=0, int endminute=0, int shift = 0)
{
   int nowtime = (Hour()+shift)*60 + Minute();
   if (nowtime < 0)
      nowtime += 1440;
   if (nowtime >= 1440)
      nowtime -= 1440;
   int starttime = starthour*60 + startminute;
   int endtime = endhour*60 + endminute;

   if (starttime <= endtime)
   {
      if ((nowtime < starttime) || (nowtime >= endtime))
         return(false);
   }
   else
   {
      if ((nowtime < starttime) && (nowtime >= endtime))
         return(false);
   }
   return(true);
}

//+------------------------------------------------------------------+
//+------------------Count Number of Open Orders---------------------+

int CountOpenOrders(int direction)
{
int i,j;
   

   
   j  =  0;
   
   for(i=OrdersTotal()-1;i>=0;i--)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==True)
            {
               if(   OrderType()          == direction   &&
                     OrderSymbol()        == Symbol()          &&
                     OrderMagicNumber()   == magic_number     
                 )
                     j++;
            }
         else
            Print("Could not SELECT trade");
      }
   
   return(j);
}

//+------------------------------------------------------------------+
//+-------------------Close Trades by Symbol-------------------------+

int CloseTrades(int direction)
{
int j;
//double ClosePrice;

   j  =  0;
   
   if(direction==-1)
      return;
      
   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
      {
         if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==True)
            {
               if(OrderSymbol()==Symbol() && 
                  OrderMagicNumber()==magic_number)                     
                  if(OrderType()==direction)
                     {
                        if(OrderType()==OP_BUY)
                           {
                              //ClosePrice  =  Bid;
                              if(OrderClose(OrderTicket(),OrderLots(),Bid,0))
                                 j++;
                           }
                        else
                           if(OrderType()==OP_BUYLIMIT)
                              {
                                 OrderDelete(OrderTicket());
                                 j++;
                              }
                        
                        if(OrderType()==OP_SELL)
                           {
                              //ClosePrice  =  Ask;
                              if(OrderClose(OrderTicket(),OrderLots(),Ask,0))
                                 j++;
                           }
                        else
                           if(OrderType()==OP_SELLLIMIT)
                              {
                                 OrderDelete(OrderTicket());
                                 j++;
                              }
                     }
            }
      }
   
   return(j);
}

//+------------------------------------------------------------------+
//+-----------------Close All Position in Account--------------------+

int CloseAll(int direction)
{
int j;
//double ClosePrice;

   j  =  0;
   
   if(direction==-1)
      return;
      
   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
      {
         if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==True)
            {                    
                  if(OrderType()==direction)
                     {
                        if(OrderType()==OP_BUY)
                           {
                              //ClosePrice  =  Bid;
                              if(OrderClose(OrderTicket(),OrderLots(),Bid,0))
                                 j++;
                           }
                        else
                           if(OrderType()==OP_BUYLIMIT)
                              {
                                 OrderDelete(OrderTicket());
                                 j++;
                              }
                        
                        if(OrderType()==OP_SELL)
                           {
                              //ClosePrice  =  Ask;
                              if(OrderClose(OrderTicket(),OrderLots(),Ask,0))
                                 j++;
                           }
                        else
                           if(OrderType()==OP_SELLLIMIT)
                              {
                                 OrderDelete(OrderTicket());
                                 j++;
                              }
                     }
            }
      }
   
   return(j);
}

//+------------------------------------------------------------------+
//+----------------Modify Profit Target and Stop Loss----------------+

void ModifyProfitTarget(int myTicket, double ProfitTarget, double StopLoss)
{
   if(OrderSelect(myTicket,SELECT_BY_TICKET,MODE_TRADES)==False)
      return;
            
      if(
            (
               ProfitTarget   != OrderTakeProfit()
               ||
               StopLoss       != OrderStopLoss()
            )                  
        )
            OrderModify(OrderTicket(),OrderOpenPrice(),StopLoss,ProfitTarget,OrderExpiration());
}

//+------------------------------------------------------------------+
//+----------------Sum of Current Order Profit per Symbol------------+


double current_symbol_profit() 
{
   double sum=0;
   int total=OrdersTotal();  
   int ordertype;  
   if (total==0) {return (0);}
   int ticket; 
   

      for(int i=total-1;i>=0;i--)
         {
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
               {
                  if(OrderSymbol()==Symbol() && 
                     OrderMagicNumber()==magic_number) 
                     {    
                        ordertype=OrderType();
                        ticket=OrderTicket();
         
                        switch(ordertype)
                           {
                              case OP_BUY:
                                 {
                                    sum=sum+OrderSwap()+OrderCommission()+OrderProfit();               
                                    break;
                                 }
                  
                              case OP_SELL:
                                 {
                                    sum=sum+OrderSwap()+OrderCommission()+OrderProfit();
                                    break;
                                 }
                  
                              default:
                                 break;
                           }    
                     }         
               }
         }

   return(sum);
}


//+------------------------------------------------------------------+
//+----------Sum of Current Pips Profit per Symbol-------------------+


int current_symbol_profit_pips() 
{
   int sum=0;
   int total=OrdersTotal();  
   int ordertype;  
   if (total==0) {return (0);}
   int ticket; 
   double priceClose;
   

      for(int i=total-1;i>=0;i--)
         {
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
               {
                  if(OrderSymbol()==Symbol() && 
                     OrderMagicNumber()==magic_number) 
                     {    
                        ordertype=OrderType();
                        ticket=OrderTicket();
         
                        switch(ordertype)
                           {
                              case OP_BUY:
                                 {
                                    priceClose=MarketInfo(OrderSymbol(),MODE_BID);                             	              
                                    sum=sum+MathRound((priceClose-OrderOpenPrice())/myPoint);               
                                    break;
                                 }
                  
                              case OP_SELL:
                                 {
                                    priceClose=MarketInfo(OrderSymbol(),MODE_ASK);
                                    sum=sum+MathRound((OrderOpenPrice()-priceClose)/myPoint);
                                    break;
                                 }
                  
                              default:
                                 break;
                           }    
                     }         
               }
         }

   return(sum);
}


//+------------------------------------------------------------------+
//+---------------------------Random Function------------------------+

double MathRandRange(double percent,double input)
{

   double high_range;
   double low_range;

   high_range=input+(percent*input/100);
   low_range=input-(percent*input/100);
   if(MathAbs(high_range-low_range)==0) high_range=high_range-1;
   return(low_range+MathMod(MathRand(),MathAbs(high_range-low_range)));
}

//+------------------------------------------------------------------+
//+---------------Traling Stop Function for Buy Position-------------+


void TrailingPositionsBuy(int trailingStop) 
{ 
   for(int i=0;i<OrdersTotal();i++) 
      { 
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_number) 
            { 
               if(OrderType()==OP_BUY) 
                  { 
                     if(Bid-OrderOpenPrice()>trailingStop*Point) 
                        { 
                           if(OrderStopLoss()+Point<=Bid-trailingStop*Point || OrderStopLoss()==0)   
                           {
                              ModifyProfitTarget(OrderTicket(), OrderTakeProfit(), Bid-trailingStop*Point); 
                           }
                        }
                  }    
             }
      }
} 
   

//+------------------------------------------------------------------+
//+---------------Traling Stop Function for Sell Position-------------+

void TrailingPositionsSell(int trailingStop) 
{ 
   for(int i=0;i<OrdersTotal();i++) 
   { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_number) 
      { 
         if(OrderType()==OP_SELL) 
         { 
            if(OrderOpenPrice()-Ask>trailingStop*Point) 
               { 
                  if(OrderStopLoss()-Point>=Ask+trailingStop*Point || OrderStopLoss()==0)  
                     {  
                        ModifyProfitTarget(OrderTicket(), OrderTakeProfit(), Ask+trailingStop*Point); 
                     }
               }
         }
      }
   }
} 
    

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+


